Sisällys

# GoSub...Return Statement

Calls a subroutine that is indicated by a label inside a Sub or a Function. The statements following the label are executed until the next Return statement. Afterwards, the program continues with the statement that follows the GoSub statement.

### Syntaksi:

    GoSub label[:]

### Parametrit:

label: A line identifier indicating where to continue execution. The scope of a label in that of the routine it belongs to.

The GoSub statement calls a local subroutine indicated by a label from within a subroutine or a function. The name of the label must end with a colon (":").

      Sub/Function foo
          ' statements
          GoSub label
          ' statements
          Exit Sub/Function
      label:
          ' statements
          Return
      End Sub/Function

Jos ohjelma tulee Return-lauseeseen, jota ei edellä GoSub-lause, LibreOffice Basic palauttaa virheilmoituksen. Käytä Exit Sub- tai Exit Function-lauseita varmistamaan, että ohjelma poistuu Sub- tai Function-rutiinista ennen seuraavaa Return-lausetta.

Seuraavassa esimerkissä havainnollistetaan GoSub- ja Return-lauseiden käyttöä. Aliohjelmaosio suoritetaan kahdesti, kun ohjelma laskee kahden käyttäjän syöttämän luvun neliöjuuren.

### Esimerkki:

    Sub ExampleGoSub
    Dim iInputa As Single
    Dim iInputb As Single
    Dim iInputc As Single
        iInputa = Int(InputBox$ ("Anna ensimmäinen luku: ","NumberInput"))
        iInputb = Int(InputBox$ ("Anna ensimmäinen luku: ","NumberInput"))
        iInputc=iInputa
        GoSub SquareRoot
        Print "Neliöjuuri luvusta";iInputa;" on";iInputc
        iInputc=iInputb
        GoSub SquareRoot
        Print "Neliöjuuri luvusta";iInputb;" on";iInputc
        Exit Sub
    SquareRoot:
        iInputc=sqr(iInputc)
        Return
    End Sub

Aiheeseen liittyvää

GoTo Statement

On...GoSub Statement; On...GoTo Statement